<template>
  <div>
    <el-card>
      <el-form :model="erpQuery"  label-width="120px" v-show="showSearch">
        <el-row>
          <el-col :span="6">
            <el-form-item label="产品编码:">
              <el-input v-model="erpQuery.code" style="width: 90%"
                        placeholder="请输入产品编码/商品条码/医保编码" clearable="true"
                        @keyup.enter.native="keyupErp_submit($event)"
              ></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item label="产品名称:">
              <el-input
                v-model="erpQuery.name" style="width: 90%"
                placeholder="请输入产品名称" clearable="true"
                @keyup.enter.native="keyup_submit($event)"
              ></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item label="规格型号:">
              <el-input
                v-model="erpQuery.spec" style="width: 90%"
                placeholder="请输入规格型号" clearable="true"
                @keyup.enter.native="keyupErp_submit($event)"
              ></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item label="注册/备案凭证号:">
              <el-input
                v-model="erpQuery.registerNo" clearable="true"
                placeholder="请输入注册/备案凭证号"
                style="width: 90%"
                @keyup.enter.native="keyup_submit($event)"
              ></el-input>
            </el-form-item>
          </el-col>
        </el-row>

        <el-row>
          <el-col :span="6">
            <el-form-item label="生产厂家:">
              <el-input
                v-model="erpQuery.manufactory" clearable="true"
                placeholder="请输入生产厂家"
                style="width: 90%"
                @keyup.enter.native="keyup_submit($event)"
              ></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item label="配送企业:">
              <el-input
                v-model="erpQuery.supName" clearable="true"
                placeholder="请输入配送企业"
                style="width: 90%"
                @keyup.enter.native="keyup_submit($event)"
              ></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item label="外部系统:">
              <el-select v-model="thirdSysFk" style="width: 90%" placeholder="请设置主系统" disabled="isImport">
                <el-option
                  v-for="item in thirdSys"
                  :key="item.value"
                  :label="item.thirdName"
                  :value="item.thirdId"
                >
                  <span style="float: left">{{ item.thirdName }}</span>
                  <span
                    style="float: right; color: #8492a6; font-size: 13px"
                  >{{ item.thirdId }}</span>
                </el-option>
              </el-select>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>


      <div class="top-right-btn">
        <el-button-group style="display:flex;">
          <el-button icon="el-icon-view" type="primary" @click="hideSearch">显示/隐藏搜索栏</el-button>
          <el-button type="primary" icon="el-icon-refresh" @click="onReset">重置</el-button>
          <el-button type="primary" icon="el-icon-search" @click="searchErpList">查询</el-button>
          <el-button type="primary" icon="el-icon-bottom-right" @click="combine" :loading="combineLoading">选入
          </el-button>
          <el-button type="primary" icon="el-icon-bottom-right" @click="combineAll" v-if="isImport  &&  !supEnable">
            结果全部选入
          </el-button>
        </el-button-group>
      </div>
      <el-divider style="margin: 15px"></el-divider>

      <el-table :data="erpList" style="width: 100%" border highlight-current-row="true" v-loading="erpLloading"
                @current-change="handleErpChange" @selection-change="handleSelectionChange"
      >
        <el-table-column v-if="isImport" type="selection" width="55"></el-table-column>
        <el-table-column label="序号" type="index"></el-table-column>
        <el-table-column label="产品编码" prop="code"></el-table-column>
        <el-table-column label="产品名称" prop="name"></el-table-column>
        <el-table-column label="计量单位" prop="measname"></el-table-column>
        <el-table-column label="规格型号" prop="spec"></el-table-column>
        <el-table-column label="注册/备案凭证号" prop="registerNo"></el-table-column>
        <el-table-column label="生产厂家" prop="manufactory"></el-table-column>
        <el-table-column label="配送企业" prop="supName"></el-table-column>
      </el-table>

      <pagination
        v-show="pageTotal>0"
        :total="pageTotal"
        :limit.sync="erpQuery.limit"
        :page.sync="erpQuery.page"
        @pagination="handleErpPageChange"
      ></pagination>
    </el-card>

    <el-card  v-if="!isImport">
      <div  style="margin-bottom: 20px">
        <el-form label-width="150px">
        <el-row>
          <el-col :span="12" >
            <el-form-item label="产品名称:">
              <el-input style="width: 90%" size="small" :disabled="true" v-model="data.cpmctymc"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="12" >
            <el-form-item label="产品标识:">
              <el-input style="width: 90%" :disabled="true" size="small" splaceholder="请输入内容" v-model="data.nameCode"></el-input>
            </el-form-item>
          </el-col>
        </el-row>

        <el-row>
          <el-col :span="12" class="el-col">
            <el-form-item label="规格型号:">
              <el-input style="width: 90%" :disabled="true" size="small" splaceholder="请输入内容" v-model="data.ggxh"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="12" class="el-col">
            <el-form-item label="医疗器械注册人:">
              <el-input style="width: 90%" :disabled="true" size="small" splaceholder="ylqxzcrbarmc" v-model="data.ylqxzcrbarmc"></el-input>
            </el-form-item>
          </el-col>
        </el-row>

        <el-row>
          <el-col :span="12" class="el-col">
            <el-form-item label="产品名称:">
              <el-input style="width: 90%" :disabled="true" size="small" splaceholder="请输入内容" v-model="data.ylqxzcrbarywmc"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="12" class="el-col">
            <el-form-item label="器械类别:">
              <el-input style="width: 90%" :disabled="true" size="small" splaceholder="请输入内容" v-model="data.qxlb"></el-input>
            </el-form-item>
          </el-col>
        </el-row>

        <el-row>
          <el-col :span="12" class="el-col">
            <el-form-item label="产品类别:">
              <el-input style="width: 90%" :disabled="true" size="small" splaceholder="请输入内容" v-model="data.cplb"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="12" class="el-col">
            <el-form-item label="分类编码:">
              <el-input style="width: 90%" :disabled="true" size="small" splaceholder="请输入内容" v-model="data.flbm"></el-input>
            </el-form-item>
          </el-col>
        </el-row>

        <el-row>
          <el-col :span="12" class="el-col">
            <el-form-item label="商品条码:">
              <el-input style="width: 90%" :disabled="true" size="small" splaceholder="请输入内容" v-model="data.sptm"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="12" class="el-col">
            <el-form-item label="医保编码:">
              <el-input style="width: 90%" :disabled="true" size="small" splaceholder="请输入内容" v-model="data.ybbm"></el-input>
            </el-form-item>
          </el-col>
        </el-row>

        <el-row>
          <el-col :span="12" class="el-col">
            <el-form-item label="统一社会信用号:">
              <el-input style="width: 90%" :disabled="true" size="small" splaceholder="请输入内容" v-model="data.tyshxydm"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="12" class="el-col">
            <el-form-item label="注册证/备案号:">
              <el-input style="width: 90%" :disabled="true" size="small" splaceholder="请输入内容" v-model="data.zczbhhzbapzbh"></el-input>
            </el-form-item>
          </el-col>
        </el-row>
        </el-form>
      </div>
    </el-card>
  </div>

</template>

<script>
import { modifyRel, addErp, addAllErp, combineUdi } from '@/api/basic/udiRelevance'
import { getInvbasdoc } from '@/api/basic/getErps'
import { getBasicThirdSys } from '@/api/basic/basicThirdSys'

export default {
  name: 'closeDialog',
  props: {
    uuid: {
      type: Object,
      required: true
    },

    data: {
      type: Object,
      required: true
    },

    relId: {
      type: Number,
      required: true
    },

    isImport: {
      type: Boolean,
      required: true
    },

    closeDialog: {
      type: Function,
      required: true
    },
    defaultSys: {
      type: Object,
      required: true
    },
    supEnable: {
      type: Object,
      required: true
    },
    intentThirdId: {
      type: Object,
      required: true
    }

  },

  data() {
    return {
      showSearch: true,
      erpQuery: {
        code: null,
        name: null,
        spec: null,
        registerNo: null,
        manufactory: null,
        thirdSys: null,
        supName: null,
        measname: null,
        page: 1,
        limit: 10

      },
      combineLoading: false,
      combineQuery: {
        thirdId: '',
        relId: '',
        erpName: '',
        keys: [],
        thirdIds: [],
        thirdSys: null,
        query: null,
        isRlInv: null,
        manufactory: null,
        measname: null,
        ybbm: null,
        sptm: null
      },

      udidlList: [],
      erpList: [],
      pageTotal: 1,
      total: 1,
      currentRow: null,
      loading: false,
      erpLloading: false,
      multipleUdiSelection: [],
      thirdSys: [],
      thirdSysFk: null
    }
  },
  methods: {
    onReset() {
      this.$router.push({
        path: ''
      })
      this.erpQuery = {
        code: null,
        name: null,
        spec: null,
        registerNo: null,
        manufactory: null,
        thirdSys: null,
        supName: null,
        measname: null,
        page: 1,
        limit: 10
      }
      this.getErpList()
    },
    tableRowClassName({ row }) {
      if (row.checked) return 'warning-row'
      return ''
    },
    checkSelectable(row) {
      return !row.checked
    },
    handleCurrentChange(val) {
      this.unionQuery.page = val
      this.getList()
    },
    handleErpChange(val) {
      console.log(val)
      this.currentRow = val
    },
    handleErpPageChange(val) {
      this.erpQuery.page = val.page
      this.getErpList()
    },

    searchErpList() {
      this.erpQuery.page = 1
      this.getErpList()
    },

    keyup_submit(event) {

      this.erpQuery.page = 1
      this.getErpList()
      event.target.select()
    },
    getErpList() {
      this.erplLoading = true
      this.erpQuery.thirdSys = this.thirdSysFk
      getInvbasdoc(this.erpQuery)
        .then((response) => {
          this.erplLoading = false
          if (response.code == 20000) {
            this.erpList = response.data.list || []
            this.pageTotal = response.data.total || 0
          } else {
            this.$message.error(response.message)
            this.erpList = []
            this.pageTotal = 0
          }
        })
        .catch(() => {
          this.erplLoading = false
          this.erpList = []
          this.pageTotal = 0
        })
    },
    intentBack() {
      this.closeDialog()
    },
    hideSearch() {
      this.showSearch = !this.showSearch
    },
    combineAll() {

      this.$confirm('此操作将在后台自动下载所有查询结果, 是否继续?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      })
        .then(() => {
          this.combineQuery.thirdSys = this.thirdSysFk
          this.combineQuery.query = this.erpQuery
          addAllErp(this.combineQuery)
            .then((response) => {
              if (response.code == 20000) {
                this.$message.success(response.data)
                this.$emit('closeUdi', true)
              } else {
                this.$message.error(response.message)
                this.$emit('closeUdi', false)
              }
            })
            .catch(() => {
              this.$emit('closeUdi', false)
            })
        })
        .catch(() => {
        })

    },

    combine() {
      this.combineQuery.query = null
      this.combineQuery.relId = this.relId
      this.combineQuery.thirdSys = this.thirdSysFk
      this.combineQuery.supEnable = this.supEnable
      if (this.isImport) {
        this.combineQuery.thirdId = null
        let selectData = this.multipleUdiSelection
        let selected = ''
        selectData.forEach((row) => {

          if (row.checked) {
            selected = selected + row.code + ','
          }
          this.combineQuery.thirdIds.push(row.code)
          this.combineQuery.manufactory = row.manufactory
          this.combineQuery.measname = row.measname

        })
        if (this.currentRow != null) {
          this.combineQuery.manufactory = this.currentRow.manufactory
          this.combineQuery.measname = this.currentRow.measname
        }

        if (selectData.length == 0) {
          this.$message.warning('未选择产品')
          return
        }
        if (selected != '') {
          this.$confirm('产品编码：' + selected + '已被添加,是否继续添加', '提示', {
            confirmButtonText: '确定',
            cancelButtonText: '取消',
            type: 'warning'
          })
            .then(() => {
              this.combineLoading = true
              combineUdi(this.combineQuery)
                .then((response) => {
                  this.combineLoading = false
                  if (response.code == 20000) {
                    this.$emit('closeUdi', true)
                    this.$message.success(response.data)
                  } else {
                    this.$message.error(response.message)
                  }
                })
                .catch(() => {
                  this.combineLoading = false
                  this.combineQuery.thirdIds = []
                  this.$emit('closeUdi', false)

                })
            })
            .catch(() => {
              this.combineQuery.thirdIds = []
            })
        } else {
          combineUdi(this.combineQuery)
            .then((response) => {
              this.combineLoading = false
              if (response.code == 20000) {
                this.$emit('closeUdi', true)
                this.$message.success(response.data)
              } else {
                this.$emit('closeUdi', false)
                this.$message.warning(response.message)
              }
            })
            .catch(() => {
              this.combineLoading = false
              this.$emit('closeUdi', false)
            })
        }

      } else {
        this.combineQuery.thirdId = this.currentRow.code
        this.combineQuery.erpName = this.currentRow.name
        this.combineQuery.manufactory = this.currentRow.manufactory
        this.combineQuery.measname = this.currentRow.measname
        this.combineQuery.ybbm = this.currentRow.ybbm
        this.combineQuery.sptm = this.currentRow.sptm
        this.erpQuery.manufactory = this.currentRow.manufactory
        this.erpQuery.measname = this.currentRow.measname
        this.combineQuery.price = this.currentRow.price

        if (this.currentRow.checked) {

          this.$confirm('产品编码：' + this.currentRow.code + '已被选入,是否继续选入', '提示', {
            confirmButtonText: '确定',
            cancelButtonText: '取消',
            type: 'warning'
          })
            .then(() => {
              this.combineLoading = true
              modifyRel(this.combineQuery)
                .then((response) => {
                  this.combineLoading = false
                  if (response.code == 20000) {
                    this.$emit('closeUdi', true)
                  } else {
                    this.$emit('closeUdi', false)
                    this.$message.error(response.message)
                  }
                })
                .catch(() => {
                  this.combineLoading = false
                  this.$emit('closeUdi', false)
                })
            })
        } else {
          this.combineLoading = true
          modifyRel(this.combineQuery)
            .then((response) => {
              this.combineLoading = false
              if (response.code == 20000) {
                this.$emit('closeUdi', true)
              } else {
                this.$emit('closeUdi', false)
                this.$message.error(response.message)
              }
            })
            .catch(() => {
              this.combineLoading = false
              this.$emit('closeUdi', false)
            })
        }

      }
    },

    handleSelectionChange(val) {
      console.log('----' + val)
      this.multipleUdiSelection = val
    },
    getBasicThirdSys() {
      let query = {
        enabled: true,
        mainSys: false,
        filter: true
      }
      if (this.isImport) {
        query.mainSys = true
      }
      getBasicThirdSys(query)
        .then((response) => {
          this.thirdSys = response.data.list || []
          this.thirdSysFk = this.thirdSys[0].thirdId
          if (this.defaultSys != null) {
            this.thirdSysFk = this.defaultSys
          }
          this.searchErpList()

        })
        .catch(() => {
          this.loading = false
          this.list = []
        })
    }
  },
  created() {
    console.log('-------------' + this.uuid)
    this.getBasicThirdSys()
    this.erpQuery.code = this.intentThirdId

  }
}
</script>

<style scoped>


</style>
